orb

- Main Page
- Tutorials
- Functions
- Release Notes
- Examples

Functions
orb
Complete List of ArrayFire Functions ArrayFire Functions by Category » Computer Vision » | Feature descriptors

ORB Feature descriptor. More...

## Functions
AFAPI void | orb (features &feat, array &desc, const array &image, const float fast_thr=20.f, const unsigned max_feat=400, const float scl_fctr=1.5f, const unsigned levels=4, const bool blur_img=false)
| C++ Interface for ORB feature descriptor. More...
AFAPI af_err | af_orb (af_features *feat, af_array *desc, const af_array in, const float fast_thr, const unsigned max_feat, const float scl_fctr, const unsigned levels, const bool blur_img)
| C Interface for ORB feature descriptor. More...

## Detailed Description

ORB Feature descriptor.

Extract ORB descriptors from FAST features that hold higher Harris responses. FAST does not compute orientation, thus, orientation of features is calculated using the intensity centroid. As FAST is also not multi-scale enabled, a multi-scale pyramid is calculated by downsampling the input image multiple times followed by FAST feature detection on each scale.

## Function Documentation

AFAPI af_err af_orb | ( | af_features * | feat,
|  | af_array * | desc,
|  | const af_array | in,
|  | const float | fast_thr,
|  | const unsigned | max_feat,
|  | const float | scl_fctr,
|  | const unsigned | levels,
|  | const bool | blur_img
| ) |  |

C Interface for ORB feature descriptor.

Parameters

  [out] | feat | af_features struct composed of arrays for x and y coordinates, score, orientation and size of selected features
  [out] | desc | Nx8 array containing extracted descriptors, where N is the number of selected features
  [in] | in | array containing a grayscale image (color images are not supported)
  [in] | fast_thr | FAST threshold for which a pixel of the circle around the central pixel is considered to be brighter or darker
  [in] | max_feat | maximum number of features to hold (will only keep the max_feat features with higher Harris responses)
  [in] | scl_fctr | factor to downsample the input image, meaning that each level will hold prior level dimensions divided by scl_fctr
  [in] | levels | number of levels to be computed for the image pyramid
  [in] | blur_img | blur image with a Gaussian filter with sigma=2 before computing descriptors to increase robustness against noise if true

AFAPI void af::orb | ( | features & | feat,
|  | array & | desc,
|  | const array & | image,
|  | const float | fast_thr = `20.f`,
|  | const unsigned | max_feat = `400`,
|  | const float | scl_fctr = `1.5f`,
|  | const unsigned | levels = `4`,
|  | const bool | blur_img = `false`
| ) |  |

C++ Interface for ORB feature descriptor.

Parameters

  [out] | feat | features object composed of arrays for x and y coordinates, score, orientation and size of selected features
  [out] | desc | Nx8 array containing extracted descriptors, where N is the number of selected features
  [in] | image | array containing a grayscale image (color images are not supported)
  [in] | fast_thr | FAST threshold for which a pixel of the circle around the central pixel is considered to be brighter or darker
  [in] | max_feat | maximum number of features to hold (will only keep the max_feat features with higher Harris responses)
  [in] | scl_fctr | factor to downsample the input image, meaning that each level will hold prior level dimensions divided by scl_fctr
  [in] | levels | number of levels to be computed for the image pyramid
  [in] | blur_img | blur image with a Gaussian filter with sigma=2 before computing descriptors to increase robustness against noise if true